#include "Python.h"
#include "numpy/arrayobject.h"

#include "stencil.h"

static PyObject* threepoint_wrapper(PyObject* self, PyObject* args) {
  double left;
  PyObject* field = 0;
  double right;

  PyObject* field_object = 0;
  double* field_pointer = 0;
  int field_size;
  
  /* Get arguments */
  PyArg_ParseTuple(args,"dOd",&left,&field,&right);
  if ( PyErr_Occurred() ) return 0;

  /* Convert numeric field to double* and size */
  field_object = field;
  PyArray_As1D(&field_object,(char**)(&field_pointer),&field_size,'d');
  
  threepoint(left,field_pointer,field_size,right);

  Py_INCREF(Py_None);
  return Py_None;
}

static PyMethodDef methods[] = {
  {"threepoint",threepoint_wrapper,METH_VARARGS,"threepoint(left_bc,field,right_bc)"},
  {0,0}
};

void initstencil(void) {
  Py_InitModule("stencil",methods);
  import_array(); /* Magic handshake for Numeric */
}
